Subject: bug#14383: cp --one-file-system / will not copy whole root filesystem

From: Bob Proulx <[email-masked]>
Date: Fri, 10 May 2013 10:35:25 -0600

severity 14383 wishlist
thanks

Pavel Machek wrote:
> On systems like linux, cp / -a --one-file-system (destination) will
> not copy whole root filesystem. It is not cp's fault, but the
> behaviour is quite surprising to the users, so maybe it would be worth
> warning in man page?
> 
> Something like
> 
>        -x, --one-file-system
>               stay on this file system
> 
> 	      Note that on systems that allow mounts over non-empty
> 	      directories (like Linux), cp / -ax (destination) will
> 	      not copy whole filesystem. In particular, content of
> 	      /dev will not be usually copied, because distributions
> 	      mount tmpfs over /dev.
> 
> [Ok, there's hopefully better wording...?]

But isn't that the entire purpose of -x?  To avoid copying files on
other file systems?

I am just not sure about having a description that is "don't copy
files on other filesystems" and then "warning: does not copy files on
other filesystems".

I have never liked the wording of "stay on this file system".  Usually
describing things in the positive, saying what it does, is best.  But
I always felt that with -x describing it in the negative, saying what
it does not do, would be better wording.

Bob